﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Background : MonoBehaviour
{
    Transform m_sky1;
    Transform m_sky2;
    Difficulty m_difficulty;

    float m_startLocation;
    float m_endLocation;
    float m_backgroundMovement1;
    float m_backgroundMovement2;
    float m_backgroundMovement1Rounded;
    float m_backgroundMovement2Rounded;

    // Start is called before the first frame update
    void Start()
    {
        GameObject sky1 = GameObject.Find("Sky1");
        GameObject sky2 = GameObject.Find("Sky2");
        GameObject difficulty = GameObject.Find("GameManager");

        m_sky1 = sky1.GetComponent<Transform>();
        m_sky2 = sky2.GetComponent<Transform>();
        m_difficulty = difficulty.GetComponent<Difficulty>();

        m_backgroundMovement1 = 0;
        m_backgroundMovement2 = 20;
        m_startLocation = 20;
        m_endLocation = -20;
    }

    // Update is called once per frame
    void Update()
    {
        m_backgroundMovement1 -= (Time.deltaTime * m_difficulty.difficulty)/2;
        m_backgroundMovement2 -= (Time.deltaTime * m_difficulty.difficulty)/2;

        m_backgroundMovement1Rounded = Mathf.Round(m_backgroundMovement1);
        m_backgroundMovement2Rounded = Mathf.Round(m_backgroundMovement2);

        if (m_backgroundMovement1Rounded <= m_endLocation)
        {
            m_backgroundMovement1 = m_startLocation;
        }
        if (m_backgroundMovement2Rounded <= m_endLocation)
        {
            m_backgroundMovement2 = m_startLocation;
        }

        m_sky1.position = new Vector3(m_backgroundMovement1, m_sky1.position.y, m_sky1.position.z);
        m_sky2.position = new Vector3(m_backgroundMovement2, m_sky2.position.y, m_sky2.position.z);

    }
}
