﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Gate : MonoBehaviour
{
    CurrentScore m_currentScore;
    public SpriteRenderer m_lockType;
    SpriteRenderer m_renderer;
    Transform m_transform;
    BoxCollider2D m_rigidBody;
    Difficulty m_difficulty;

    float m_gateRespawn = 8;
    float m_gateMovement = 8;
    float m_gateLoop;
    float m_randomHeight;
    float m_randomSpawn;
    float m_gateType;

    public int lockHP;

    public Sprite cracked, bronze, silver, gold, diamond;


    // Start is called before the first frame update
    void Start()
    {
        m_transform = GetComponent<Transform>();
        m_renderer = GetComponent<SpriteRenderer>();
        m_rigidBody = GetComponent<BoxCollider2D>();

        GameObject scoreValue = GameObject.Find("ScoreValue");
        GameObject lockType = GameObject.Find("Lock");
        GameObject difficulty = GameObject.Find("GameManager");

        m_currentScore = scoreValue.GetComponent<CurrentScore>();
        m_lockType = lockType.GetComponent<SpriteRenderer>();
        m_difficulty = difficulty.GetComponent<Difficulty>();

        m_randomHeight = (Random.Range(-1.5f, 4));

        PickLock();
        ResetGate();
    }

    // Update is called once per frame
    void Update()
    {
        m_randomSpawn = Mathf.Round((Random.Range(0, 100)));

        if (m_gateLoop >= -8)
        {
            m_gateMovement -= Time.deltaTime*m_difficulty.difficulty;

            m_gateLoop = Mathf.Round(m_gateMovement);

            m_transform.position = new Vector3(m_gateMovement, m_transform.position.y, m_transform.position.z);

            DisableLock(); 
        }
        else
        {
            if (m_randomSpawn == 5)
            {
                ActivateLock();
                PickLock();
                ResetGate();
            }
        }
    }

    void ActivateLock()
    {
        if (m_renderer.enabled == false)
        {
            m_renderer.enabled = true;
            m_rigidBody.enabled = true;
            m_lockType.enabled = true;
        }
    }

    void DisableLock()
    {
        if (lockHP <= 0)
        {
            m_renderer.enabled = false;
            m_rigidBody.enabled = false;
            m_lockType.enabled = false;
        }
    }

    void PickLock()
    {
        m_gateType = Mathf.Round((Random.Range(1, m_difficulty.difficulty)));

        switch (m_gateType)
        {
            case 1:
                m_lockType.sprite = cracked;
                lockHP = 1;
                break;
            case 2:
                m_lockType.sprite = bronze;
                lockHP = 2;
                break;
            case 3:
                m_lockType.sprite = silver;
                lockHP = 3;
                break;
            case 4:
                m_lockType.sprite = gold;
                lockHP = 4;
                break;
            case 5:
                m_lockType.sprite = diamond;
                lockHP = 5;
                break;
        }
    }

    void ResetGate()
    {
        m_randomHeight = (Random.Range(-1.5f, 4));
        m_gateLoop = m_gateRespawn;
        m_gateMovement = m_gateRespawn;
        m_transform.position = new Vector3(m_gateMovement, m_randomHeight, m_transform.position.z);
    }
}
