﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ItemManager : MonoBehaviour
{
    Transform m_itemLocation;
    SpriteRenderer m_itemSprite;
    Difficulty m_difficulty;
    CurrentScore m_currentScore;
    PlayerController m_player;

    float m_randomSpawn;
    float m_selectItem;
    float randomX;
    float itemStartY;
    float m_itemMovementX;
    float m_itemMovementY;

    bool activeItem;

    public Sprite egg, goldenEgg, health;

    // Start is called before the first frame update
    void Start()
    {
        GameObject itemType = GameObject.Find("CurrentItem");
        GameObject difficulty = GameObject.Find("GameManager");
        GameObject scoreValue = GameObject.Find("ScoreValue");
        GameObject playerHealth = GameObject.Find("Player");

        m_currentScore = scoreValue.GetComponent<CurrentScore>();
        m_itemLocation = itemType.GetComponent<Transform>();
        m_itemSprite = itemType.GetComponent<SpriteRenderer>();
        m_difficulty = difficulty.GetComponent<Difficulty>();
        m_player = playerHealth.GetComponent<PlayerController>();

        activeItem = false;
        itemStartY = 5.5f;
        SetLocation();
    }

    // Update is called once per frame
    void Update()
    {
        m_randomSpawn = Mathf.Round((Random.Range(0, 100)));

        if (!activeItem && m_randomSpawn <= 5)
        {  
            ActivateItem();
            PickItem();
            SetLocation();
        }
        else if (activeItem)
        {
            MoveItem();
        }
        
    }

    void PickItem()
    {
        m_selectItem = Mathf.Round((Random.Range(1, m_difficulty.difficulty)));

        switch (m_selectItem)
        {
            case 1:
                m_itemSprite.sprite = egg;
                break;
            case 2:
                m_itemSprite.sprite = goldenEgg;
                break;
            case 3:
                m_itemSprite.sprite = health;
                break;
        }
    }

    void SetLocation()
    {
        randomX = Mathf.Round((Random.Range(-3, 7)));
        m_itemLocation.position = new Vector3(randomX, itemStartY, m_itemLocation.position.z);
        m_itemMovementX = randomX;
        m_itemMovementY = itemStartY;
    }

    void MoveItem()
    {
        m_itemMovementX -= Time.deltaTime * (m_difficulty.difficulty/5);
        m_itemMovementY -= Time.deltaTime;

        m_itemLocation.position = new Vector3(m_itemMovementX, m_itemMovementY, m_itemLocation.position.z);

        CheckOnScreen();
    }

    void CheckOnScreen()
    {
        if (m_itemLocation.position.y < -3 || m_itemLocation.position.x < -6.5f)
        {
            activeItem = false;
            m_itemSprite.enabled = false;
        }
    }

    void ActivateItem()
    {
        activeItem = true;
        if (m_itemSprite.enabled == false)
        {
            m_itemSprite.enabled = true;
        }
    }

    public void CollectItem()
    {
        activeItem = false;
        m_itemSprite.enabled = false;

        switch (m_selectItem)
        {
            case 1:
                m_currentScore.m_currentScore += 5;
                break;
            case 2:
                m_currentScore.m_currentScore += 30;
                break;
            case 3:
                if (m_player.m_health < 3)
                {
                    m_player.m_health++;
                    m_player.DrawHealth();
                }
                break;
        }
    }
}
