﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Squirrel : MonoBehaviour
{
    Transform m_squirrelLocation;
    Difficulty m_difficulty;
    Rigidbody2D m_rigidbody;

    float m_scrollingMovement;
    float m_randomSpawn;
    float m_startLocation;

    bool isActive;

    // Start is called before the first frame update
    void Start()
    {
        GameObject difficulty = GameObject.Find("GameManager");

        m_squirrelLocation = GetComponent<Transform>();
        m_difficulty = difficulty.GetComponent<Difficulty>();
        m_rigidbody = GetComponent<Rigidbody2D>();

        isActive = false;
        m_startLocation = 10;
    }

    // Update is called once per frame
    void Update()
    {
        m_randomSpawn = Mathf.Round((Random.Range(0, 100)));

        if (m_squirrelLocation.position.x <= -8)
        {
            m_scrollingMovement = m_startLocation;
            isActive = false;
        }

        if (m_randomSpawn <= 5 && !isActive && m_difficulty.difficulty >= 1)
        {
            isActive = true;
            m_startLocation = 10 + Mathf.Round((Random.Range(-30, 30)));
            m_squirrelLocation.position = new Vector3(m_startLocation, m_squirrelLocation.position.y, m_squirrelLocation.position.z);
        }
        else if (isActive)
        {
            m_scrollingMovement -= (Time.deltaTime * m_difficulty.difficulty) * 3;
            m_squirrelLocation.position = new Vector3(m_scrollingMovement, (m_scrollingMovement/3), m_squirrelLocation.position.z);
        }
    }
}
